链接: http://acm.hdu.edu.cn/showproblem.php?pid=2089

Time Limit: 1000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 46291 Accepted Submission(s): 17518

Problem Description
杭州人称那些傻乎乎粘嗒嗒的人为62(音:laoer)。
杭州交通管理局经常会扩充一些的士车牌照,新近出来一个好消息,以后上牌照,不再含有不吉利的数字了,这样一来,就可以消除个别的士司机和乘客的心理障碍,更安全地服务大众。
不吉利的数字为所有含有4或62的号码。例如:
62315 73418 88914
都属于不吉利号码。但是,61152虽然含有6和2,但不是62连号,所以不属于不吉利数字之列。
你的任务是,对于每次给出的一个牌照区间号,推断出交管局今次又要实际上给多少辆新的士车上牌照了。

Input
输入的都是整数对n、m(0<n≤m<1000000),如果遇到都是0的整数对,则输入结束。

Output
对于每个整数对,输出一个不含有不吉利数字的统计个数,该数值占一行位置。

Sample Input
1 100
0 0

Sample Output
80

Author
qianneng

Source
迎接新学期——超级Easy版热身赛

题意:给定a,b,求[a,b]之间不含4和62的数字的个数
分析:数位DP ,转化为[1,b]和[1,a-1]的计算
判断某个数是否含有4可以直接判断,62因为是两位数,种类较多,用pre记录前一位的数字,若是6,判断下一位数字是否是2,若是这种情况就直接跳过

dp[pos][state] pos代表数的长度
dp[pos][0] 表示前一位数不是6的个数;dp[pos][1]表示前一位数是6的个数

#include <cstdio>
#include <cstring>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <sstream>
#include <string>
#include <set>
#include <queue>
using namespace std;
#define mem(a,n) memset(a,n,sizeof(a))
#define pb(x) push_back(x)
typedef long long LL;
typedef unsigned long long ull;
const int mod=1e9+7;
const double eps=1e-6;
const LL INF=0x3f3f3f3f;
const int N=200+5;
int dp[10][2],digit[10];
int dfs(int pos,int pre,bool state,bool bounded)
{
    if(pos==0) return 1;///枚举完毕,说明这个数合法
    if(!bounded&&dp[pos][state]!=-1)///必须判断是否为上界,否则可能发生状态冲突
        return dp[pos][state];
    int ans=0;
    int end=bounded?digit[pos]:9;
    for(int i=0; i<=end; i++)
    {
        if(i==4) continue;
        if(pre==6&&i==2) continue;///保证满足题目条件
        ans+=dfs(pos-1,i,i==6,bounded&&i==end);
    }
    if(!bounded) dp[pos][state]=ans;///
    return ans;
}
int cal(LL x)
{
    int pos=0;
    while(x)
    {
        digit[++pos]=x%10;
        x/=10;
    }
    return dfs(pos,-1,0,true);
}
int main()
{
    int a,b;
    mem(dp,-1);
    while(~scanf("%d%d",&a,&b)&&(a+b))
    {
        printf("%d\n",cal(b)-cal(a-1));
    }
    return 0;
}